# This file is part of the dune-gdt project:
#   http://users.dune-project.org/projects/dune-gdt
# Copyright holders: Felix Schindler
# License: BSD 2-Clause License (http://opensource.org/licenses/BSD-2-Clause)

dnl -*- autoconf -*-
# Macros needed to find dune-gdt and dependent libraries.  They are called by
# the macros in ${top_src_dir}/dependencies.m4, which is generated by
# "dunecontrol autogen"

# Additional checks needed to build dune-gdt
# This macro should be invoked by every module which depends on dune-gdt, as
# well as by dune-gdt itself
AC_DEFUN([DUNE_GDT_CHECKS],
[ 
  PKG_CHECK_MODULES([EIGEN],
                    [eigen3],
                    [AC_DEFINE([HAVE_EIGEN],
                               [1],
                               [Define wether the eigen includes were found.])],
                               [AC_MSG_RESULT([Package 'eigen3' was not found in the pkg-config search path.
Perhaps you should add the directory containing `eigen3.pc'
to the PKG_CONFIG_PATH environment variable.])])
  DUNE_CPPFLAGS="$DUNE_CPPFLAGS $EIGEN_CFLAGS"
])

# Additional checks needed to find dune-gdt
# This macro should be invoked by every module which depends on dune-gdt, but
# not by dune-gdt itself
AC_DEFUN([DUNE_GDT_CHECK_MODULE],
[
  DUNE_CHECK_MODULES([dune-gdt],[gdt/exists.hh])
])
